<?php
/*
Plugin Name: 
Plugin URI: http://
Description: 
Author: AuthorName <Author@Mail>
Author URI: http://
Version: 1.0
*/ 
 
class ModuleClass 
{
	var $options;
	//to do ... other class vars
	
    public function __construct()
    {

		//Actions
		add_action('admin_menu', array($this, '_add_menu'));
		add_action('init', array($this, 'init_hook'), 0);
		
		$this->options = get_option('...');

		//to do ... other actions and necessary inits
		
	}

	/* admin_menu hook */
	public function _add_menu() {
		add_options_page('Params module page', 'Params module page', 8, __FILE__, 
			array($this, '_options_page'));
	}

	/* init hook */
	public function init_hook() {
		global $user_ID, $user_login;
		// to do ...
		
	}
	
    /* Options admin page */
    public function _options_page() {
		global $wpdb, $table_prefix;
	
		switch ($_POST['action']) {
		case 'save_settings':
			//delete service fields
			unset($_POST['action'], $_POST['sbm']);
			// to do ... validate new settings
		
			update_option('...', $_POST);
			$this->options = $_POST;
			echo '<div class="updated"><p>' . __("Setting are updated.") . '</p></div>';
			
			break;
		case 'some other actoins ...':
			//do some actions
		}
		
		$acs = $this->options;

?>
<div class="wrap">
	<h2><?=__('Your module settings title');?></h2>
	<form method="post">
	<input type="hidden" name="action" value="save_settings" />
	<fieldset class="options">
		<legend></legend>
		<!-- To do ... form fields -->
	</fieldset>
	<input type="submit" class="button-primary" name="sbm" value="<?=__('Do')?>" />
	</form>
	
	<h2><?=__('Do some actions');?></h2>

</div>
<?php
    }

	/* install actions (when activate first time) */
    static function install() {
		global $wpdb;
		
		//create table(s) if it needs any
		$wpdb->query("
			CREATE TABLE IF NOT EXISTS `...` (
				...
			) ENGINE=MyISAM DEFAULT CHARSET=utf8; ");

		//set defaults
		add_option('...', ModuleClass::default_settings() );
	}

	/* Default settings */
	static function default_settings() {
		return array(
			'option1' => 'value',
			...
			);
	}
	
	/* uninstall hook */
    static function uninstall() {
		global $wpdb;

		//drop created tables and delete module options
		$wpdb->query("DROP TABLE IF EXISTS `...`");
		delete_option('...');
	}

} 

register_uninstall_hook( __FILE__, array('ModuleClass', 'uninstall'));
register_activation_hook( __FILE__, array('ModuleClass', 'install') );

if (class_exists("ModuleClass")) {
	$module_obj = new ModuleClass();
}

if (isset($module_obj)) {
	//to do ...
	;

} // if (isset($module_obj))

